#include <vector>
#include <iostream>
#include <string>

#include "safeStream.h"
#include "threadPool.h"


int fibonacci( int n ) {
    if ( n == 0 )
        return 0;
    if ( n == 1 )
        return 1;
    return fibonacci( n - 1 ) + fibonacci( n - 2 );
}

int main() {
    ThreadPool t( 3 );

    auto h = t.enqueue( fibonacci, 40 );

    for ( int i = 0; i < 20; ++i ) {
        t.enqueue( [] (int i) {
            std::chrono::seconds duration( 2 );
            std::this_thread::sleep_for( duration );

            gcout.stream() << "finished " << i << std::endl;
        }, i );
    }
    t.enqueue( [] {
        gcout.stream() << "press enter to finish" << std::endl;
    } );


    gcout.stream() << "fibonacci(40) = " << h.get() << std::endl;
    std::cin.get();
    return 0;
}

